#pragma once
#include <FK/FK.h>

class TaskManager;

class TaskBase {
private:
	friend class TaskManager;

	TaskManager*	manager;
	bool			enableFlag;

public:
	TaskBase(TaskManager * = NULL);
	virtual ~TaskBase();

	virtual void update() = 0;

	void enable(void);
	void disable(void);
	bool isEnabled(void);

};

class TaskManager {
private:
	list<TaskBase *>	taskList;

public:
	TaskManager(void);
	virtual ~TaskManager(void);

	void update(void);

	void clear(void);

	void entry(TaskBase *);
	void remove(TaskBase *);
	bool isEntried(TaskBase *);

	void toTop(TaskBase *);
	void toBottom(TaskBase *);

};

